<img align="left" src="logo/rfxgen_256x256.png" width=256>

# rFXGen
A simple and easy-to-use fx sounds generator, based on the amazing [Dr.Petter's sfxr](http://www.drpetter.se/project_sfxr.html).

rFXGen comes in two flavours: **ZERO** (free version) and **ONE** (low-cost version). You can get them [here](https://raylibtech.itch.io/rfxgen).

<br>
<br>
<br>

## rFXGen ZERO features

 - Predefined **sound presets** (Coin, Shoot, Explosion, PowerUp...)
 - Multiple wave types supported (Square, Sawtooth, Sine, Noise)
 - Up to **four save slots** to store generate sound (temporary save)
 - Load **.rfx** sounds or import **.sfs** files (compatible with sfxr)
 - Save **.rfx** sounds with generation parameters (**104 bytes only**)
 - Export **.wav** files, configurable sample-rate and bits-per-sample
 - Wave data visualization in real-time
 - **Completely portable (single file)**
 
## rFXGen ONE plus features

 - **Powerful command line for batch conversion and wave playing**
 - Export wave to **.raw** samples data and **code** bytes array (.h)
 - Three unique GUI themes: **Light, Dark, Candy**
 
## rFXGen Screenshot

![rFXGen light interface](screenshots/rfxgen_v200_light_shot01.png)
 
## rFXGen Usage

Open the tools and use buttons/slider to generate sounds in real-time for your games.
Sounds could be saved as .rfx (sound generation parameters) and also exported to .wav as sample data. 
rFXGen ONE also allows exporting sounds as .raw sample data and as a plain code byte array (.h)

rFXGen ONE comes with a powerful command line for sounds generation and manipulation. Just type on command line:

 > rfxgen.exe --help

## rFXGen License

rFXGen is **open source software**. rFXGen source code is licensed under an unmodified [zlib/libpng license](LICENSE).

rFXGen ZERO or rFXGen ONE are completely free for anyone willing to compile it directly from source. In case anyone prefers to directly [download distributed binary files](https://raylibtech.itch.io/), rFXGen ZERO is free and rFXGen ONE is low-cost. In any case, consider it as a small donation to help the author keep working on software for games development.

*Copyright (c) 2016-2019 raylib technologies ([@raylibtech](https://twitter.com/raylibtech))*
